n_w=max([length(S_w_m1) length(S_w_m2)]);
n_theta=max([length(S_theta_m1) length(S_theta_m2)]);
S_w_m1(end:n_w,1)=S_w_m1(end);
S_w_m2(end:n_w,1)=S_w_m2(end);
S_theta_m1(end:n_theta,1)=S_theta_m1(end);
S_theta_m2(end:n_theta,1)=S_theta_m2(end);
S_w=[S_w_m1 S_w_m2];
S_theta=[S_theta_m1 S_theta_m2];
Stotal=[S_w; S_theta];
%==========================================================================
%                              Lectura Parmetros
%==========================================================================
c_m1=cluster(1,1); %horizontes de control
c_m2=cluster(1,2);
alfa_w=cluster(1,3);%parmetros alfa lambda y W
alfa_theta=cluster(1,4);
lambda_m1=cluster(1,5);
lambda_m2=cluster(1,6);
w_max=cluster(1,7);
w_min=cluster(1,8);%lmites mximos y mnimos de las VC
theta_max=cluster(1,9);
theta_min=cluster(1,10);
m12_max=cluster(1,11);
m12_min=cluster(1,12);%lmites mximos y mnimos y de incrementos de las VM
delta_m12_max=cluster(1,13);
delta_m12_min=cluster(1,14);
k_w=cluster(1,15);
k_theta=cluster(1,16);
k_m12=cluster(1,17);
k_delta_m12=cluster(1,18);
tol_w=cluster(1,19);
tol_theta=cluster(1,20);
tol_m12=cluster(1,21);
tol_delta_m12=cluster(1,22);
iteraciones=cluster(1,23);%nmero de veces que se ejecuta el algoritmo recursivo para encontrar solucin
p_w=n_w+c_m1+c_m2;%horizontes de prediccin
p_theta=n_theta+c_m1+c_m2;
%==========================================================================
%                       Clculo de la matriz G
%==========================================================================
c=[c_m1 c_m2];
G=zeros(1,sum(c));
for i=1:2
    switch i;
        case 1
            p=p_w;
            n=n_w;
            S=S_w;
        case 2
            p=p_theta;
            n=n_theta;
            S=S_theta;            
    end
    Saux=[S; ones(p-n,2)*[S(end,1) 0; 0 S(end,2)]];
    Gaux=zeros(p,sum(c));
    k=0;
    for j=1:2
        for i=1:c(j);
            Gaux(i:end,k+i)=Saux(1:p-i+1,j);
        end
        k=sum(c(1:j));
    end
    G=[G;Gaux];
end
G=G(2:end,:);
%==========================================================================
%                Clculo de las matrices alfa y lambda H y Pm
%==========================================================================
alfa=alfa_w*eye(p_w,p_w);
alfa(end+1:end+p_theta,end+1:end+p_theta)=alfa_theta*eye(p_theta,p_theta);
lambda=lambda_m1*eye(c_m1,c_m1);
lambda(end+1:end+c_m2,end+1:end+c_m2)=lambda_m2*eye(c_m2,c_m2);
%==========================================================================
%               Clculo de las matrices M. estrella y T
%==========================================================================
M_w_est=zeros(n_w,n_w);
M_w_est(1:end-1,2:end)=eye(n_w-1,n_w-1);
M_w_est(end,end)=1;
M_theta_est=zeros(n_theta,n_theta);
M_theta_est(1:end-1,2:end)=eye(n_theta-1,n_theta-1);
M_theta_est(end,end)=1;
M_est=M_w_est;
M_est(end+1:end+n_theta,end+1:end+n_theta)=M_theta_est;
T=0;
for i=1:2;
    switch i
        case 1
            p=p_w;
            n=n_w;
            M=M_w_est;
        case 2
            p=p_theta;
            n=n_theta;
            M=M_theta_est;
    end
    Taux=zeros(p,n);
    Taux(1:n-1,2:end)=eye(n-1,n-1);
    Taux(n:end,end)=1.0;
    T(end+1:end+p,end+1:end+n)=Taux;
end
T=T(2:end,2:end);
%==========================================================================
% matrices de la patente y condiciones iniciales
%==========================================================================
H=inv(G'*alfa*G+lambda)*G'*alfa;
Pm0=inv(G'*alfa*G+lambda);
mfut=zeros(c_m1+c_m2,c_m1+c_m2);
for j=1:2
    if j==1;
        a=1;
        b=c_m1;
    elseif j==2
        a=c_m1+1;
        b=c_m1+c_m2;
    end
    for k=a:b;
        mfut(k,a:k)=1;
    end
end
libre0=[wmedida*ones(n_w,1);thetamedido*ones(n_theta,1)];%inicializacion de la resuesta libre
G_esp=[G(1,:);G(p_w+1,:)];


